# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from twisted.python import components
from twisted.python import reflect
from twisted.python import plugin
from twisted.python import log
from twisted.application import service

TYPE = 'adapterRegistration'

def installPlugins(plugins):
    for p in plugins:
        adapterClass = reflect.namedAny(p.adapter)
        interfaceClass = reflect.namedAny(p.interface)
        originalClass = reflect.namedAny(p.original)

        components.registerAdapter(
            adapterClass, originalClass, interfaceClass)
##         log.msg("Registered %s as an adapter for %s on %s" % (
##             p.adapter, p.original, p.interface))

done = False

def justDoIt():
    global done
    if not done:
        ## If installPlugins imports a module which tries to call justDoIt, we don't want to call installPlugins again
        done = True
        installPlugins(plugin.getPlugIns(TYPE))

class AdapterRegistrationService(service.Service):
    def startService(self):
        justDoIt()
        service.Service.startService(self)
