# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.


from twisted.trial import unittest
from twisted.python.components import Adapter, Interface, CannotAdapt

from atop.regadapt import installPlugins

class A1(Adapter):
    pass

class A2(Adapter):
    pass

class O1:
    pass

class O2:
    pass

class I1(Interface):
    pass

class I2(Interface):
    pass

class I3(Interface):
    pass

PKG = 'atop.test.test_regadapt.'

class P:
    def __init__(self, a, o, i):
        a = PKG + a
        o = PKG + o
        i = PKG + i
        self.adapter, self.original, self.interface = a, o, i

class It(unittest.TestCase):
    def testIt(self):
        installPlugins([
            P('A1', 'O1', 'I1'),
            P('A2', 'O1', 'I2'),
            P('A1', 'O2', 'I1'),
            P('A2', 'O2', 'I2'),
        ])

        self.failUnless(isinstance(I1(O1()), A1))
        self.failUnless(isinstance(I2(O1()), A2))
        self.failUnless(isinstance(I1(O2()), A1))
        self.failUnless(isinstance(I2(O2()), A2))

        self.assertRaises(CannotAdapt, I3, O1())
        self.assertRaises(CannotAdapt, I3, O2())
