# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from twisted.internet.defer import Deferred
from twisted.trial import unittest

from nevow.tags import *
from nevow import util

from nevow.renderer import DynamicRenderer


def deferit(data):
    return data.d

def deferdot(data):
    return data.d2

class LaterTest(unittest.TestCase):
    
    def setUp(self):
        self.d = Deferred()
        self.d2 = Deferred()
        self.r = DynamicRenderer(
            html(data=self)[
                'Hello ', invisible[invisible[invisible[invisible[deferit]]]],
                deferdot,
            ]
        )

    def test_deferredSupport(self):
        req = util.FakeRequest()
        self.r.render(req)
        self.assertEquals(req.v, '<html>Hello ')
        self.d.callback("world")
        self.assertEquals(req.v, '<html>Hello world')
        self.d2.callback(".")
        self.assertEquals(req.v, '<html>Hello world.</html>')


    def test_deferredSupport(self):
        req = util.FakeRequest()
        self.r.buffered = True
        self.r.render(req)
        self.assertEquals(req.v, '')
        self.d.callback("world")
        self.assertEquals(req.v, '')
        self.d2.callback(".")
        self.assertEquals(req.v, '<html>Hello world.</html>')
