# -*- test-case-name: quotient.test.test_searchup -*-

# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

import os

from atop.powerup import Powerup
from atop.tpython import Forgetter
from atop.store import IPipe, Pool, NameIndex

from lupy.indexer import Index

from mimemessage import  ICleanPoint, EmailPowerup

from twisted.python import log
from twisted.internet import threads, reactor
from twisted.internet import defer
from twisted.python.components import Interface, implements

from stats import Statoscope

from quotient import taglib
from quotient.web.root import Base
from quotient.proto.smtpout import IOutgoingMail, OutgoingMailup
from quotient.prefup import touchNForward

from nevow import tags
from nevow import formless
from nevow import freeform

class IAddressBook(Interface):
    def search(self, query):
        pass

class AddressBookDisplay(Base):
    __implements__ = IAddressBook
    
    document = taglib.page(title="Address Book")[
        tags.p["Address Book"],
    ]
    
    def render(self, request):
        getByID = self.original.store.getItemByID
        if request.args.has_key('add'):
            personId = request.args['add'][0]
            person = getByID(int(personId))
            self.original.addPerson(person)
            request.redirect(request.getHeader('referer'))
        elif request.args.has_key('remove'):
            personId = request.args['remove'][0]
            person = getByID(int(personId))
            self.original.removePerson(person)
            request.redirect(request.getHeader('referer'))
        return Base.render(self, request)

    
class AddressBook(Powerup):
    __implements__ = IPipe, IAddressBook, Powerup.__implements__,
    dependencies = []
    powerupName = 'Address Book'

    # TODO - Provisioning and Statoscope
    def setUpPools(self, avatar):
        avatar.setComponent(IAddressBook, self)
        p = Pool(avatar, name='Address Book')
        p.addIndex(NameIndex())
        self.addressPoolRef = p.referenceTo()
        avatar.getRootPool().addItem(p)
        self.invisible = True

    def addPerson(self, person):
        """
        We have to find a better way of doing this.
        Until then, some brittle code.
        """
        def _():
            self.addressPool().addItem(person)
        self.store.transact(_)

    def removePerson(self, person):
        """
        We have to find a better way of doing this.
        Until then, some brittle code.
        """
        def _():
            self.addressPool().removeItem(person)
        self.store.transact(_)

    def addressPool(self):
        return self.addressPoolRef.getItem()
