# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from nevow import iwoven
from twisted.python import components


class ITabularRenderer(iwoven.IRendererFactory):
    """An item which can be rendered in a table. ITabularRenderer
    implementors have render_foo methods which represent columns
    which this tabular renderer is able to render.

    render_foo methods for use in rendering cellls have attributes
    set on them which indicate whether they should be shown
    by default and how wide the column should be by default.
    These attributes are:
    
    render_foo.position = int   # columns will be sorted on this before rendering.
    render_foo.default = bool  # if this is set to False, this column will not be rendered by default.
    render_foo.width = int      # This number is the default width of the column, in pixels.
    """
    invisible = property(doc = """If set to true, this item will not be
    rendered in the table.""")




