# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.


test_messages = [
"""To: testguy@testplace.test.thing
From: More@test.strings
Date: Fri, 29 Aug 2002 01:37:00 -0600
Message-ID: <this.string.is.unique.in.the.known.universe@but.what.about.the.unknown>
Content-Type: text/plain
Content-Length: short
Lines: 3

Here is
A few
Lines of content!
""",
"""Header-Followed-By-Tab-Instead-Of-Space:	A Tab Preceeds This String
Return-Path: <twisted-python-admin@twistedmatrix.com>
Delivered-To: exarkun@meson.dyndns.org
Received: from pyramid.twistedmatrix.com (adsl-64-123-27-105.dsl.austtx.swbell.net [64.123.27.105])
	by meson.dyndns.org (Postfix) with ESMTP id C8E6613E93
	for <exarkun@meson.dyndns.org>; Sun, 20 Oct 2002 15:46:37 -0400 (EDT)
Received: from localhost ([127.0.0.1] helo=pyramid.twistedmatrix.com)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 183Lzd-0000Cx-00; Sun, 20 Oct 2002 14:44:09 -0500
Received: from rack.gnubian.org ([209.61.188.219])
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 183LzM-0000C3-00
	for <twisted-python@twistedmatrix.com>; Sun, 20 Oct 2002 14:43:52 -0500
Received: from localhost.localdomain (cs666980-243.satx.rr.com [66.69.80.243])
	(authenticated bits=0)
	by rack.gnubian.org (8.12.5/8.12.5/Debian-1) with ESMTP id g9KJpQsG013802
	for <twisted-python@twistedmatrix.com>; Sun, 20 Oct 2002 14:51:26 -0500
Subject: Re: [Twisted-Python] enterprise.row and two-way relationships
From: Justin Ryan <justin@gnubian.org>
To: twisted-python@twistedmatrix.com
In-Reply-To: <20021020185058.GA783@orcrist>
References: <1035069693.944.10.camel@qutang>  <20021020185058.GA783@orcrist>
Content-Type: multipart/signed; micalg=pgp-sha1; protocol="application/pgp-signature";
	boundary="=-7s/NEw7xLXyUeykx6FS7"
X-Mailer: Ximian Evolution 1.0.8 
Message-Id: <1035143074.872.5.camel@qutang>
Mime-Version: 1.0
Sender: twisted-python-admin@twistedmatrix.com
Errors-To: twisted-python-admin@twistedmatrix.com
X-BeenThere: twisted-python@twistedmatrix.com
X-Mailman-Version: 2.0.11
Precedence: bulk
Reply-To: twisted-python@twistedmatrix.com
List-Help: <mailto:twisted-python-request@twistedmatrix.com?subject=help>
List-Post: <mailto:twisted-python@twistedmatrix.com>
List-Subscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=subscribe>
List-Id: Twisted Python discussion stuff <twisted-python.twistedmatrix.com>
List-Unsubscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=unsubscribe>
List-Archive: <http://twistedmatrix.com/pipermail/twisted-python/>
Date: 20 Oct 2002 14:44:33 -0500


--=-7s/NEw7xLXyUeykx6FS7
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

On Sun, 2002-10-20 at 13:50, Ken Kennedy wrote:
> On Sat, Oct 19, 2002 at 06:21:32PM -0500, Justin Ryan wrote:
> > Hello..
> >=20
> > To solve this problem, I've got a 'rel' table which keeps relationships
> > between account ids and contact ids, so if I want all of the contacts
> > for account x I simply pull all of the rows out of the 'rel' table whos=
e
> > accountId is x, and then individually step through them and extract the
> > contacts with the corresponding accountIds..
> >=20
> > I don't think there is a problem with the way I'm doing this, or a
> > better way to do this (though I'd be tickled if someone could point me =
a
> > better way), but in any case there does not seem to be an (obvious) way
> > to handle this with RowObjects..
>=20
> It's a little unclear, but the "pull all of the rows out..and then
> individually step through them" seems to suggest you're making two
> queries to the db. If that's the case,then yeah, there's a better
> way. If you know the accountID (from some previous query), just join
> rel to contacts:
>=20
> "select contact_info from contacts inner join rel on (rel.contactid =3D
> contacts.contactid) where rel.accountid =3D whatever"=20
>=20
> If you only know account name info, use:
>=20
> "select contact_info from=20
>        accounts inner join rel on (rel.accountid =3D accounts.accountid)
>        inner join
>        contacts on (contacts.contactid=3Drel.contactid)
>        where account.accountname =3D 'whatever'
> "
>=20
> Either way, you should be getting back what you need in one
> query. Does that make sense?
>=20

Certainly.., and it's not that far off from what I was doing.. except it
does seem a bit off in that no info is actually being pulled from the
account table - and if it were, it would be pulled multiple times (if i
want to pull the account name and account id, and then a list of
contacts).

the big important question here is ('scuse my german)... *drumroll*

how the fuck do I do this with twisted.enterprise.row? ;)

Unfortunately, the documentation for row seems pretty sketchy and shows
a direct parent-child relationship (room->furniture)..

it seems very unimportant what the underlying SQL does if row is
supposed to abstract it anyway..

any idears?

Thanks again!

-Justin

--=-7s/NEw7xLXyUeykx6FS7
Content-Type: application/pgp-signature; name=signature.asc
Content-Description: This is a digitally signed message part

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.2.0 (GNU/Linux)

iD8DBQA9swehEdFoPd10Cu0RAqrmAKCVGb8Pm2eCu6xBwtZWcVHRJrPDQACeNyxg
vcvJ4p64gr2+8CVFo7+s+ng=
=I9yy
-----END PGP SIGNATURE-----

--=-7s/NEw7xLXyUeykx6FS7--


_______________________________________________
Twisted-Python mailing list
Twisted-Python@twistedmatrix.com
http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python
""",
"""Envelope-to: test@domain.tld
Received: from pool-138-88-80-171.res.east.verizon.net
	([138.88.80.171] helo=meson.dyndns.org ident=69gnV1Y3MozcsVOT)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 181WHR-0002Rq-00
	for <test@domain.tld>; Tue, 15 Oct 2002 13:18:57 -0500
Received: by meson.dyndns.org (Postfix, from userid 1000)
	id 34DEB13E95; Tue, 15 Oct 2002 14:20:18 -0400 (EDT)
Date: Tue, 15 Oct 2002 14:20:18 -0400
From: Jp Calderone <exarkun@blargchoo.choo.choo.dyndns.org>
To: test@domain.tld
Subject: [user@address: My Cool Apartment!]
Message-ID: <20021015182018.GA11673@unique.oh.yea>
Mime-Version: 1.0
Content-Type: multipart/signed; micalg=x-unknown;
	protocol="application/pgp-signature"; boundary="24zk1gE8NUlDmwG9"
Content-Disposition: inline
User-Agent: Mutt/1.3.25i
Content-Length: 2003
Lines: 72
Status: RO
x-pop3-uid: 3dbf299600000017 twistedmatrix.com


--24zk1gE8NUlDmwG9
Content-Type: multipart/mixed; boundary="h31gzZEtNLTqOjlF"
Content-Disposition: inline


--h31gzZEtNLTqOjlF
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable


--=20
   Know what I pray for? The strength to change what I can, the inability to
accept what I can't and the incapacity to tell the difference.    -- Calvin
--
 2:00pm up 147 days, 14:57, 4 users, load average: 0.00, 0.02, 0.00

--h31gzZEtNLTqOjlF
Content-Type: message/rfc822
Content-Disposition: inline

Return-Path: <dynamox@springstreet.com>
Delivered-To: thisuser@guy.wherever
Received: from mx1.springstreet.com (unknown [206.131.172.28])
	by meson.dyndns.org (Postfix) with ESMTP id E027314187
	for <exarkun@choo.choo.choo.dyndns.org>; Wed, 18 Sep 2002 00:27:14 -0400 (EDT)
Received: from app2.springstreet.com (app2.admin.springstreet.com
	[10.0.149.2])
	by mx1.springstreet.com (8.11.6/8.11.6) with ESMTP id g8I4RUe47820
	for <exarkun@xxxx.org>; Tue, 17 Sep 2002 21:27:30 -0700 (PDT)
	(envelope-from dynamox@springstreet.com)
Received: (from dynamox@localhost)
	by app2.springstreet.com (8.10.2+Sun/8.10.2) id g8I4RUb22565;
	Tue, 17 Sep 2002 21:27:30 -0700 (PDT)
Date: Tue, 17 Sep 2002 21:27:30 -0700 (PDT)
Message-Id: <200209180427.g8I4RUb22565@app2.springstreet.com>
To: this.field.is.for@the.user.it.is.for
From: someuser@anotherdomain.com
SUBJECT: My Cool Apartment!

jp,

Hey! Check out this great apartment I found at Homestore.com apartments & 
rentals! You can visit it here:
http://www.springstreet.com/propid/246774?source=1xxctb079


cathedral ceilings



<message id:1032323249933719>

--h31gzZEtNLTqOjlF--

--24zk1gE8NUlDmwG9
Content-Type: application/pgp-signature
Content-Disposition: inline

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1


-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.0.7 (GNU/Linux)

iD8DBQE9rFxhedcO2BJA+4YRAjZqAKC6jZcmEZu0tInRreBjTbFcIh7rfACdEDhZ
oTZw+Ovl1BvLcE+pK9VFxxY=
=Uds2
-----END PGP SIGNATURE-----

--24zk1gE8NUlDmwG9--
""",

"""Envelope-to: test@domain.tld
Received: from dsl093-082-039.wdc1.dsl.speakeasy.net ([66.93.82.39]
	helo=mail.wooz.org)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 182wKl-0000fN-00; Sat, 19 Oct 2002 11:20:15 -0500
Received: by mail.wooz.org (Postfix, from userid 500)
	id CC5E31BF6E4; Sat, 19 Oct 2002 12:21:43 -0400 (EDT)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="OwHEpO+hOl"
Content-Transfer-Encoding: 7bit
Message-ID: <15793.34455.512573.39157@gargle.gargle.HOWL>
Date: Sat, 19 Oct 2002 12:21:43 -0400
To: Jp Calderone <test@domain.tld>
Cc: mailing.list@place.what
Subject: Re: nntp protocol supports moderated newsgroups?
References: <15791.12797.768063.913733@gargle.gargle.HOWL>
	<3DAF3453.4030306@twistedmatrix.com>
	<15791.13852.867292.398473@gargle.gargle.HOWL>
	<3DAF3952.4050707@twistedmatrix.com>
X-Mailer: VM 7.07 under 21.4 (patch 9) "Informed Management" XEmacs Lucid
From: user@name.tld
X-Attribution: BAW
X-Oblique-Strategy: Speaking children
X-Url: http://barry.wooz.org
Content-Length: 9389
Lines: 242
Status: RO
x-pop3-uid: 3dbf299600000020 twistedmatrix.com


--OwHEpO+hOl
Content-Type: text/plain; charset=us-ascii
Content-Description: message body text
Content-Transfer-Encoding: 7bit


>>>>> "JC" == Jp Calderone <test@domain.tld> writes:

    JC>  Hmm, twisted/news/database.py should have all the stuff it
    JC> needs already - maybe makeGroupSQL() will need to be modified
    JC> a bit so that twisted/tap/news.py can tell it which groups
    JC> should be moderated and which shouldn't.  twisted/tap/news.py
    JC> will probably have most of the action; it'll need code to let
    JC> the user specify moderated/unmoderated to mktap somehow, maybe
    JC> with another --groups parameter, or with some indicator in the
    JC> groups file.

    JC> Maybe it's time twisted.news got a *real* configuration
    JC> interface :) I'll ponder that a little (maybe something fun
    JC> with woven), and if you(/anyone else) have any ideas on this,
    JC> I'd love to hear them.

I don't really, since I'm fairly green in my Twisted use.  I will note
that the news stuff seems a little more difficult to use than when I
last looked at it (Twisted 0.19 I think).  I'm using Twisted from cvs
now, so it's possible this stuff is just in flux.

Specifically:

- What is the --servers switch for?  I couldn't actually find where
  that was used in tap/news.py but it seemed required, so I fed it
  nonsense. 

- I understand why "mktap news" requires an extra argument now, but it
  would be nice if either the pickle or sql command were defaulted.  I
  don't think I needed to specify "mktap news pickle" last time.  Hmm,
  maybe if --file is given you can default to pickle?

- I noticed some bugs in the code, a few of which I fixed, but some I
  didn't.  I ran the server w/ twistd -n and watched the output.  I
  got mysterious log messages such as:

[...]
19/10/2002 11:54 [*news*] Starting factory <twisted.news.news.UsenetClientFactory instance at 0x82a52d4>
19/10/2002 11:54 [*news*] Connection failed: [Failure instance: Traceback! exceptions.IOError, address not found
19/10/2002 11:54 [*news*] ]
19/10/2002 11:54 [*news*] Connection failed: [Failure instance: Traceback! exceptions.IOError, address not found
19/10/2002 11:54 [*news*] ]
19/10/2002 11:54 [*news*] Stopping factory <twisted.news.news.UsenetClientFactory instance at 0x82a52d4>
19/10/2002 11:55 [*news*] Starting factory <twisted.news.news.UsenetClientFactory instance at 0x82a52d4>
[...]

  While these repeated as long as the server was running, they didn't
  seem to affect its operation.

- In news/news.py, buildProtocol() is trying to pass self.remoteHosts
  to the self.protocol() call, but self.protocol() -- which is really
  the nntp.NNTPServer class, doesn't take two arguments.

In any event, I hacked in moderated group support by adding a
-m/--moderators flag, which takes a file containing a list of
newsgroup/moderator address pairs.  When a message is POSTed to a
group, the list of target newsgroups is checked against the
moderators.  If there is any match, and the article has no Approved
header, the article is not posted, but instead emailed to the
moderators address.  The value of the Approved header is completely
ignored -- it just has to be there.  I believe this is pretty close to
how Usenet s/w handles moderators.

A couple of kludges that should be cleaned up:

- What to do if the list of target newsgroups has more than one
  moderated newsgroup in it?  Off hand, I'm not sure what Usenet does
  in this case.

- We really need a few more config options, including the smtp host
  and port to use to send out the moderator's email, and the envelope
  sender address to use in that email.  Both are hard coded in my
  hack.

- Any un-Twisted coding offenses. :)

So, in the grand tradition of scratching my own itch, but just enough
so I can sleep, here's the patch.

Oh, BTW, for someone who was completely green to the code base,
Twisted is very nicely written.  It wasn't difficult at all to drill
down to where I needed to make the changes.  JP's hints helped a lot
too.  Yay!

Enjoy,
-Barry


--OwHEpO+hOl
Content-Type: text/plain
Content-Description: Patch to Twisted news for moderation support
Content-Disposition: inline;
	filename="twisted.txt"
Content-Transfer-Encoding: 7bit

Index: twisted/news/database.py
===================================================================
RCS file: /cvs/Twisted/twisted/news/database.py,v
retrieving revision 1.15
diff -u -r1.15 database.py
--- twisted/news/database.py	3 Oct 2002 14:40:32 -0000	1.15
+++ twisted/news/database.py	19 Oct 2002 15:54:26 -0000
@@ -34,6 +34,7 @@
 from twisted.persisted import dirdbm
 
 import getpass, pickle, time, socket, md5, string
+import smtplib
 
 ERR_NOGROUP, ERR_NOARTICLE = range(2, 4)  # XXX - put NNTP values here (I guess?)
 
@@ -221,9 +222,9 @@
 
     sharedDBs = {}
 
-    def __init__(self, filename, groups = None):
+    def __init__(self, filename, groups = None, moderators = None):
         self.datafile = filename
-        self.load(filename, groups)
+        self.load(filename, groups, moderators)
 
     def listRequest(self):
         "Returns a list of 4-tuples: (name, max index, min index, flags)"
@@ -235,7 +236,10 @@
                 high = max(self.db[i].keys()) + 1
             else:
                 low = high = 0
-            flags = 'y'
+            if self.db['moderators'].has_key(i):
+                flags = 'm'
+            else:
+                flags = 'y'
             r.append((i, high, low, flags))
         return defer.succeed(r)
 
@@ -250,6 +254,25 @@
         groups = string.split(a.getHeader('Newsgroups'))
         xref = []
 
+        # first see if any groups are moderated.  if so, nothing gets posted,
+        # but the whole messages gets forwarded to the moderator address
+        moderator = None
+        for group in groups:
+            moderator = self.db['moderators'].get(group)
+            if moderator:
+                break
+        # Moderated postings go through as long as they have an Approved
+        # header, regardless of what the value is
+        if moderator and not a.getHeader('Approved'):
+            a.putHeader('To', moderator)
+            s = smtplib.SMTP()
+            s.connect()
+            s.sendmail('twisted@%s' % socket.gethostname(),
+                       [moderator],
+                       a.textHeaders() + a.body)
+            s.quit()
+            return defer.succeed(None)
+
         for group in groups:
             if self.db.has_key(group):
                 if len(self.db[group].keys()):
@@ -360,7 +383,7 @@
         pickle.dump(self.db, open(self.datafile, 'w'))
 
 
-    def load(self, filename, groups = None):
+    def load(self, filename, groups = None, moderators = None):
         if PickleStorage.sharedDBs.has_key(filename):
             self.db = PickleStorage.sharedDBs[filename]
         else:
@@ -373,6 +396,11 @@
                 if groups is not None:
                     for i in groups:
                         self.db[i] = {}
+                if moderators is not None:
+                    dmod = {}
+                    for g, m in moderators:
+                        dmod[g] = m
+                    self.db['moderators'] = dmod
                 self.flush()
 
 
Index: twisted/news/news.py
===================================================================
RCS file: /cvs/Twisted/twisted/news/news.py,v
retrieving revision 1.8
diff -u -r1.8 news.py
--- twisted/news/news.py	16 Oct 2002 04:27:39 -0000	1.8
+++ twisted/news/news.py	19 Oct 2002 15:54:26 -0000
@@ -89,7 +89,7 @@
 
 
     def buildProtocol(self, connection):
-        p = self.protocol(self.remoteHosts)
+        p = self.protocol()
         p.factory = self
         return p
 
Index: twisted/tap/news.py
===================================================================
RCS file: /cvs/Twisted/twisted/tap/news.py,v
retrieving revision 1.10
diff -u -r1.10 news.py
--- twisted/tap/news.py	8 Oct 2002 15:53:51 -0000	1.10
+++ twisted/tap/news.py	19 Oct 2002 15:54:26 -0000
@@ -62,15 +62,23 @@
 
         # XXX - Hrm.
         ["groups",     "g", "groups.list",   "File containing group list"],
-        ["servers",    "s", "servers.list",  "File containing server list"]
+        ["servers",    "s", "servers.list",  "File containing server list"],
+        ["moderators", "m", "moderators.list",
+         "File containing moderators list"],
     ]
 
     def postOptions(self):
         # XXX - Hmmm.
-        self['groups'] = [g.strip() for g in open(self['groups']).readlines() if not g.startswith('#')]
-        self['servers'] = [s.strip() for s in open(self['servers']).readlines() if not s.startswith('#')]
-
-        self.db = database.PickleStorage(filename, self['groups'])
+        filename = self['file']
+        self['groups'] = [g.strip() for g in open(self['groups']).readlines()
+                          if not g.startswith('#')]
+        self['servers'] = [s.strip() for s in open(self['servers']).readlines()
+                           if not s.startswith('#')]
+        self['moderators'] = [s.split()
+                              for s in open(self['moderators']).readlines()
+                              if not s.startswith('#')]
+        self.db = database.PickleStorage(filename, self['groups'],
+                                         self['moderators'])
 
 
 class Options(usage.Options):

--OwHEpO+hOl--
""",

"""Envelope-to: test@domain.tld
Received: from usw-sf-sshgate.sourceforge.net ([216.136.171.253]
	helo=usw-sf-netmisc.sourceforge.net)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 183ySu-0007l4-00
	for <test@domain.tld>; Tue, 22 Oct 2002 07:48:56 -0500
Received: from usw-sf-web4-b.sourceforge.net ([10.3.1.24]
	helo=usw-sf-web4.sourceforge.net)
	by usw-sf-netmisc.sourceforge.net with esmtp (Exim 3.22 #1 (Debian))
	id 183yUx-0006tG-00
	for <test@domain.tld>; Tue, 22 Oct 2002 05:51:03 -0700
Received: from nobody by usw-sf-web4.sourceforge.net with local (Exim 3.33 #1
	(Debian))	id 183yUx-0005SN-00
	for <test@domain.tld>; Tue, 22 Oct 2002 05:51:03 -0700
To: test@domain.tld
Subject: SourceForge Project Approved
From: noreply@sourceforge.net
Message-Id: <E183yUx-0005SN-00@usw-sf-web4.sourceforge.net>
Date: Tue, 22 Oct 2002 05:51:03 -0700
Content-Length: 1914
Lines: 42
Status: RO
x-pop3-uid: 3dbf29960000002b twistedmatrix.com

Your project registration for SourceForge has been approved. 

Project Full Name:  Pynfo - Python IRC bot
Project Unix Name:  pynfo
CVS Server:         cvs.pynfo.sourceforge.net
Shell/Web Server:   pynfo.sourceforge.net

Your DNS will take up to a day to become active on our site.
While waiting for your DNS to resolve, you may try shelling into 
shell.sourceforge.net and pointing CVS to cvs.sourceforge.net.

If after 6 hours your shell/CVS accounts still do not work, please
open a support ticket so that we may take a look at the problem.
Please note that all shell/CVS accounts are closed to telnet and only
work with SSH1.

Your web site is accessible through your shell account. Please read
site documentation (see link below) about intended usage, available 
services, and directory layout of the account.

Please take some time to read the site documentation about project
administration (http://sourceforge.net/docs/site/). If you visit your 
own project page in SourceForge while logged in, you will find 
additional menu functions to your left labeled 'Project Admin'. 

We highly suggest that you now visit SourceForge and create a public
description for your project. This can be done by visiting your project
page while logged in, and selecting 'Project Admin' from the menus
on the left (or by visiting https://sourceforge.net/project/admin/?group_id=65337
after login).

Your project will also not appear in the Trove Software Map (primary
list of projects hosted on SourceForge which offers great flexibility in
browsing and search) until you categorize it in the project administration 
screens. So that people can find your project, you should do this now. 
Visit your project while logged in, and select 'Project Admin' from the 
menus on the left.

Enjoy the system, and please tell others about SourceForge. Let us know
if there is anything we can do to help you.

 -- the SourceForge crew
""",
"""Return-Path: <twisted-python-admin@twistedmatrix.com>
Delivered-To: exarkun@meson.dyndns.org
Received: from pyramid.twistedmatrix.com (adsl-64-123-27-105.dsl.austtx.swbell.net [64.123.27.105])
	by meson.dyndns.org (Postfix) with ESMTP id BF1081414A
	for <exarkun@meson.dyndns.org>; Fri, 23 Aug 2002 07:50:16 -0400 (EDT)
Received: from localhost ([127.0.0.1] helo=pyramid.twistedmatrix.com)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 17iCgf-0001Eg-00; Fri, 23 Aug 2002 06:33:09 -0500
Received: from 209-189-198-108.puremagic.com ([209.189.198.108] helo=bellevue.puremagic.com)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 17iCg4-0001EI-00
	for <twisted-python@twistedmatrix.com>; Fri, 23 Aug 2002 06:32:32 -0500
Received: from cubik.org (dnvrdslgw17poolb218.dnvr.uswest.net [63.231.84.218])
	by bellevue.puremagic.com (8.12.5/8.12.5/Debian-1) with ESMTP id g7NBnRnJ012012
	for <twisted-python@twistedmatrix.com>; Fri, 23 Aug 2002 04:49:27 -0700
Message-ID: <3D66221C.90802@cubik.org>
From: Bruce Mitchener <bruce@cubik.org>
User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.0rc2) Gecko/20020510
X-Accept-Language: en-us, en
MIME-Version: 1.0
To: twisted-python@twistedmatrix.com
Subject: Re: [Twisted-Python] epydoc and Twisted
References: <3D650A6B.6060606@cubik.org>	<1030039417.7568.2.camel@radii>	<3D6529A1.6060007@cubik.org> <20020823.003547.126575962.glyph@twistedmatrix.com>
Content-Type: text/plain; charset=us-ascii; format=flowed
Content-Transfer-Encoding: 7bit
X-Virus-Scanned: by amavisd-milter (http://amavis.org/)
Sender: twisted-python-admin@twistedmatrix.com
Errors-To: twisted-python-admin@twistedmatrix.com
X-BeenThere: twisted-python@twistedmatrix.com
X-Mailman-Version: 2.0.11
Precedence: bulk
Reply-To: twisted-python@twistedmatrix.com
List-Help: <mailto:twisted-python-request@twistedmatrix.com?subject=help>
List-Post: <mailto:twisted-python@twistedmatrix.com>
List-Subscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=subscribe>
List-Id: Twisted Python discussion stuff <twisted-python.twistedmatrix.com>
List-Unsubscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=unsubscribe>
List-Archive: <http://twistedmatrix.com/pipermail/twisted-python/>
Date: Fri, 23 Aug 2002 05:53:00 -0600

Glyph Lefkowitz wrote:
> "It's not just a good idea, it's the law."
> 
> This should be in the coding standard.  While I wouldn't take a lot of
> developer time that might be better spent elsewhere to go through and insert
> this meta-information, we really ought to be getting the most out of the
> documentation system we use.

Good good.  I'll make those changes to the standards.

> We should also write a silly hack to allow any module to import without
> ImportErrors.  I think this would fix most of the doc generation issues?

This takes more Python clue than I'v currently been gifted with. :) I'll 
see about scaring up some work out of dash, radix, itamar, or some other 
local smartie.

  - Bruce


_______________________________________________
Twisted-Python mailing list
Twisted-Python@twistedmatrix.com
http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python
""",
"""From: Exar Kun <exarkun@blargchoo.choo.choo.dyndns.org>
To: test@example.com
Date: Fri, 29 Aug 2002 01:37:10 -0600
Subject: test

More tests!
""",
"""To: testguy@testplace.test.thing
From: Test User <More@test.strings>
Date: Fri, 29 Aug 2002 01:37:20 -0600
Message-ID: <this.string.is.unique.in.the.known.universe@but.what.about.the.unknown.1>
Content-Type: text/plain
Content-Length: short
Lines: 3

Here is
A few
Lines of content!
""",
"""To: testguy@testplace.test.thing
From: Test User <More@test.strings>
Date: Fri, 29 Aug 2002 01:37:21 -0600
Message-ID: <this.string.is.unique.in.the.known.universe@but.what.about.the.unknown.2>
Content-Type: text/plain
Content-Length: short
Lines: 3

Here is
A few
Lines of content!
""",
"""Return-Path: <twisted-python-admin@twistedmatrix.com>
Delivered-To: exarkun@meson.dyndns.org
Received: from pyramid.twistedmatrix.com (adsl-64-123-27-105.dsl.austtx.swbell.net [64.123.27.105])
	by meson.dyndns.org (Postfix) with ESMTP id DD9521414A
	for <exarkun@meson.dyndns.org>; Sat, 24 Aug 2002 22:35:33 -0400 (EDT)
Received: from localhost ([127.0.0.1] helo=pyramid.twistedmatrix.com)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 17imyb-0004YG-00; Sat, 24 Aug 2002 21:18:05 -0500
Received: from adsl-64-123-27-105.dsl.austtx.swbell.net ([64.123.27.105] helo=localhost.localdomain)
	by pyramid.twistedmatrix.com with esmtp (Exim 3.35 #1 (Debian))
	id 17imy5-0004XN-00
	for <twisted-python@twistedmatrix.com>; Sat, 24 Aug 2002 21:17:34 -0500
Subject: RE: [Twisted-Python] Proposed Website Comp
From: Christopher Armstrong <radix@twistedmatrix.com>
To: Twisted ML <twisted-python@twistedmatrix.com>
In-Reply-To:
	<!~!UENERkVCMDkAAQACAAAAAAAAAAAAAAAAABgAAAAAAAAA/oXuKv271EyqITBPzRe8l8KAAAAQ
	AAAASj9Jwy6e0UiuLYNHY9WcJwEAAAAA@markrichman.com>
References:
	<!~!UENERkVCMDkAAQACAAAAAAAAAAAAAAAAABgAAAAAAAAA/oXuKv271EyqITBPzRe8l8KAAAAQ
	AAAASj9Jwy6e0UiuLYNHY9WcJwEAAAAA@markrichman.com>
Content-Type: multipart/signed; micalg=pgp-sha1; protocol="application/pgp-signature";
	boundary="=-y4K5gnrIV2V16RyUNv7t"
X-Mailer: Ximian Evolution 1.0.8 
Message-Id: <1030242925.2584.34.camel@radii>
Mime-Version: 1.0
Sender: twisted-python-admin@twistedmatrix.com
Errors-To: twisted-python-admin@twistedmatrix.com
X-BeenThere: twisted-python@twistedmatrix.com
X-Mailman-Version: 2.0.11
Precedence: bulk
Reply-To: twisted-python@twistedmatrix.com
List-Help: <mailto:twisted-python-request@twistedmatrix.com?subject=help>
List-Post: <mailto:twisted-python@twistedmatrix.com>
List-Subscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=subscribe>
List-Id: Twisted Python discussion stuff <twisted-python.twistedmatrix.com>
List-Unsubscribe: <http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python>,
	<mailto:twisted-python-request@twistedmatrix.com?subject=unsubscribe>
List-Archive: <http://twistedmatrix.com/pipermail/twisted-python/>
Date: 24 Aug 2002 22:35:17 -0400


--=-y4K5gnrIV2V16RyUNv7t
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

On Sat, 2002-08-24 at 22:12, Mark A. Richman wrote:
> This is why I called it a "comp" - I'm not going to waste my time with
> "real" HTML, CSS, etc. if you aren't going to like it...which you have
> made abundantly clear.

I think you got the wrong idea -- glyph did say that it was visually
pleasing (or something similar). It was only technical things that he
had criticisms for, and I agree with him full-heartedly. I think it's
sexy as well, it just needs to be hacked on to be not so blatantly
platform-dependant.

> I simply created it as a springboard for discussion, and not as a beta
> of any kind.

I think it looks awesome, but I agree with glyph's points. Is there any
chance you'll address some of the points he made? I can't say I'll be
able to help much, but I'd like to (and surely others would be able to
lend a hand here and there).

[snip to glyph...]
> > * You're using tables for all formatting, rather than CSS.  This is a
> > notorious
> > error that most experienced web designers seem to shudder at.  I guess
> > this

I thought this point was funny, considering the existing site uses
tables for formatting as well ;-)

--=20
                                Chris Armstrong
                         << radix@twistedmatrix.com >>
                http://twistedmatrix.com/users/radix.twistd/

--=-y4K5gnrIV2V16RyUNv7t
Content-Type: application/pgp-signature; name=signature.asc
Content-Description: This is a digitally signed message part

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.0.7 (GNU/Linux)

iD8DBQA9aEJlNp279O1/OG4RAsyXAJoDtYNw7sc41rB1Yts4GY1m9oUYKQCfShfi
zJW9/3um7dqmKB1HsPhLnGw=
=N4i2
-----END PGP SIGNATURE-----

--=-y4K5gnrIV2V16RyUNv7t--


_______________________________________________
Twisted-Python mailing list
Twisted-Python@twistedmatrix.com
http://twistedmatrix.com/cgi-bin/mailman/listinfo/twisted-python
"""
]

html_messages = ['''\
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML><HEAD><TITLE></TITLE>
<META http-equiv=Content-Type content="text/html; charset=iso-8859-1">
<META content="MSHTML 6.00.2800.1170" name=GENERATOR>
<STYLE></STYLE>
</HEAD>
<BODY bgColor=#ffffff>
<DIV><FONT face=Arial size=2>Oops!</FONT></DIV>
<DIV><FONT face=Arial size=2>Yes, thanks Wouter, I did :-)</FONT></DIV>
<DIV><FONT face=Arial size=2></FONT>&nbsp;</DIV>
<BLOCKQUOTE dir=ltr 
style="PADDING-RIGHT: 0px; PADDING-LEFT: 5px; MARGIN-LEFT: 5px; BORDER-LEFT: #000000 2px solid; MARGIN-RIGHT: 0px">
  <DIV style="FONT: 10pt arial">----- Original Message ----- </DIV>
  <DIV 
  style="BACKGROUND: #e4e4e4; FONT: 10pt arial; font-color: black"><B>From:</B> 
  <A title=mmunge@address href="mailto:munge@address">Wouter van 
  Vliet</A> </DIV>
  <DIV style="FONT: 10pt arial"><B>To:</B> <A title=users@httpd.apache.org 
  href="mailto:users@httpd.apache.org">users@httpd.apache.org</A> </DIV>
  <DIV style="FONT: 10pt arial"><B>Sent:</B> Monday, November 10, 2003 5:40 
  PM</DIV>
  <DIV style="FONT: 10pt arial"><B>Subject:</B> RE: [users@httpd] 
.htaccess</DIV>
  <DIV><BR></DIV>
  <DIV dir=ltr align=left><FONT face=Arial color=#0000ff size=2><SPAN 
  class=343523617-10112003>Daniel probably meant: "<STRONG>note</STRONG> the 
  leading dot" instead of "not" .. it\'s kinda to very important 
  :P</SPAN></FONT></DIV><FONT face=Arial color=#0000ff size=2></FONT><BR>
  <BLOCKQUOTE 
  style="PADDING-LEFT: 5px; MARGIN-LEFT: 5px; BORDER-LEFT: #0000ff 2px solid; MARGIN-RIGHT: 0px">
    <DIV class=OutlookMessageHeader lang=en-us dir=ltr align=left>
    <HR tabIndex=-1>
    <FONT face=Tahoma size=2><B>From:</B> Daniel Clarke - JASWW 
    [mailto:another@munged] <BR><B>Sent:</B> maandag 10 november 2003 
    16:57<BR><B>To:</B> <A 
    href="mailto:users@httpd.apache.org">users@httpd.apache.org</A><BR><B>Subject:</B> 
    Re: [users@httpd] .htaccess<BR></FONT><BR></DIV>
    <DIV></DIV>
    <DIV><FONT face=Arial size=2>Hi Dayne</FONT></DIV>
    <DIV><FONT face=Arial><FONT size=2>Create a file called .htaccess (not the 
    leading dot) and put it in the directory that your customer 404 should apply 
    to.<SPAN class=343523617-10112003><FONT 
    color=#0000ff>&nbsp;</FONT></SPAN></FONT></FONT></DIV>
    <DIV><FONT face=Arial><FONT size=2><SPAN 
    class=343523617-10112003></SPAN></FONT></FONT><FONT face=Arial 
    size=2></FONT>&nbsp;</DIV>
    <DIV><FONT face=Arial size=2>In the file, put:</FONT></DIV>
    <DIV><FONT face=Arial size=2>&nbsp;&nbsp;&nbsp; &nbsp; ErrorDocument 404 
    /path/to/error404.html</FONT></DIV>
    <DIV><FONT face=Arial size=2>Note that the path to the error file has a 
    slash at the beginning</FONT></DIV>
    <DIV><FONT face=Arial size=2>You could also use</FONT></DIV>
    <DIV><FONT face=Arial size=2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ErrorDocument 
    404 /error404.html</FONT></DIV>
    <DIV><FONT face=Arial size=2></FONT>&nbsp;</DIV>
    <DIV><FONT face=Arial size=2>Note also that this error404.html should NOT 
    have any protection on it!</FONT></DIV>
    <DIV>&nbsp;</DIV>
    <DIV><FONT face=Arial size=2>Make sure that your ISP or sys admin has 
    allowed you to use custom .htaccess docs.</FONT></DIV>
    <DIV><FONT face=Arial size=2></FONT>&nbsp;</DIV>
    <BLOCKQUOTE 
    style="PADDING-RIGHT: 0px; PADDING-LEFT: 5px; MARGIN-LEFT: 5px; BORDER-LEFT: #000000 2px solid; MARGIN-RIGHT: 0px">
      <DIV style="FONT: 10pt arial">----- Original Message ----- </DIV>
      <DIV 
      style="BACKGROUND: #e4e4e4; FONT: 10pt arial; font-color: black"><B>From:</B> 
      <A title=more@munging href="mailto:away@munge">Dayne</A> </DIV>
      <DIV style="FONT: 10pt arial"><B>To:</B> <A title=users@httpd.apache.org 
      href="mailto:users@httpd.apache.org">users@httpd.apache.org</A> </DIV>
      <DIV style="FONT: 10pt arial"><B>Sent:</B> Sunday, November 09, 2003 8:28 
      PM</DIV>
      <DIV style="FONT: 10pt arial"><B>Subject:</B> [users@httpd] 
.htaccess</DIV>
      <DIV><BR></DIV><FONT size=2><FONT face=Arial,sans-serif>I\'m trying to make 
      custom 404 pages by making a .htaccess file.&nbsp; I reviewed the 
      documentation on .htaccess files on apache.org but now I\'m even more 
      confused than before.&nbsp; Can someone try to explain it 
      PLEASE!?!?<BR><BR>-Dayne<BR></FONT></FONT>--------------------------------------------------------------------- 
      The official User-To-User support forum of the Apache HTTP Server Project. 
      See <URL:HTTP: userslist.html httpd.apache.org>for more info. To 
      unsubscribe, e-mail: users-unsubscribe@httpd.apache.org " from the digest: 
      users-digest-unsubscribe@httpd.apache.org For additional commands, e-mail: 
      users-help@httpd.apache.org 
    </BLOCKQUOTE><BR>________________________________________________________________________<BR>This 
    email has been scanned for all viruses by MDaemon PRO v6.8.4 R<BR>on Mon, 10 
    Nov 2003 15:56:52 -0000 and found to contain no infected <BR>attachments. 
    The virus list was updated on Mon 2003-11-10 
    15:30:33<BR>________________________________________________________________________ 
  </BLOCKQUOTE></BLOCKQUOTE></BODY></HTML>


<html>
<br>
________________________________________________________________________<br>
This email has been scanned for all viruses by MDaemon PRO v6.8.4 R<br>
on Mon, 10 Nov 2003 17:47:30 -0000 and found to contain no infected <br>
attachments. The virus list was updated on Mon 2003-11-10 17:30:41<br>
________________________________________________________________________</html>
'''
]
