#from twisted.trial import unittest

from twisted.python import log
from twisted.python.util import OrderedDict
from twisted.web.microdom import parseString
from twisted.web.domhelpers import findElementsWithAttribute as findwa
from twisted.web.domhelpers import findNodes as findn
from twisted.web.domhelpers import findNodesNamed as findnn
from twisted.web.domhelpers import gatherTextNodes as gather

from os.path import join as opj

from quotient.web import functional

dontGoThere = ['/perspective-destroy', '/perspective-init']
badKeys = ['Next', 'Previouw', 'Prev', 'Logout']


#class TracingMetaclass(type):
#    def makeTraceFunc(klass, funcname, funcobj):
#        origFuncName = funcobj.func_name
#        funcobj.func_name = '_' + origFuncName
#        def f(self, funcobj, *a, **kw):
#            print funcname
#            funcobj(*a, **kw)
#        f = types.FunctionType(f.func_code, f.func_globals, origFuncName, f.func_defaults, f.func_closure)
#        return (f, funcobj)
#
#    def __new__(klass, name, bases, attrs):
#        for funcname, funcobj in attrs:
#            if funcname != '__init__':
#                tracer, altfunc = makeTraceFunc(funcname, funcobj)
#                attrs[tracer.func_name] = tracer
#                attrs[altfunc.func_name] = altfunc

        
class SimpleSpider(functional.FunctionalBase, object):
    urldict = {}
    harvestedURLs = []
    def __init__(self):
        #print 'SimpleSpider.__init__'
        functional.FunctionalBase.setUpClass(self)
#        import sys; sys.settrace(self.globalTrace)

    def globalTrace(self, frame, event, arg):
        co = frame.f_code
        #if event == 'call':
            #print "%s:%s - %s" % (co.co_filename, frame.f_lineno, co.co_name)
        if event == 'return':
            print " --- return --- "
        if co.co_name == "dealWithError":
            print "%s:%s - %s" % (co.co_filename, frame.f_lineno, co.co_name)

        return None

    def crawl(self):
        print "\n\nSPIDER IS CRAWLING!\n\n"
        self.seedUrls()
        self.harvestUrls()
        self.cleanup()
        self.fixUrls()

    def fixUrls(self):
        """adds a /me if necessary"""
        #print 'fixUrls'
        keys = self.urldict.keys()
        vals = self.urldict.values()
        remove = []
        for i, v in enumerate(vals):
            if v in dontGoThere:
                remove.append(i)
                continue
            if '/me' not in v:
                vals[i] = opj('/me', v)

            # i can do this because i know that 
            # len(keys) == len(values)
            if keys[i] in badKeys:
                #print '\n\nFOUND BAD KEY %s!!\n\n\n' % keys[i]
                remove.append(i)
        for i in remove:
            del keys[i]
            del vals[i]
        
        self.urldict = dict(zip(keys, vals))
  
    def cleanup(self):
        #print 'cleanup'
        functional.FunctionalBase.tearDownClass(self)


    def updateUrlDict(self, domstr):
        #print 'updateUrlDict'
        newdict = {}
        try:
            dom = parseString(domstr)
            for node in findnn(dom,'a'):
                if len(node.childNodes) == 1:
                    name = node.childNodes[0].nodeValue
                    if name not in self.urldict.keys():
                        url = node.getAttribute('href')
                        newdict[name] = url
                        #print 'name %s: = url: %s' % (name, url)

        # TODO: get rid of this stupidity
        except Exception, e:
            log.msg(e)
        else:
            self.urldict.update(newdict)

    def harvestUrls(self):
        #print 'harvestUrls'
        for url in self.urldict.values():
            if url in dontGoThere:
                continue
            if '/me' not in url:
                #print 'getting /me/%s' % url
                self.doGet('/me/%s' % url, skipRestOnError=False)
            else:
                self.doGet(url)
            self.updateUrlDict(self.result)
        self.fixUrls()

    def seedUrls(self):
        #print 'seedUrls'
        self.doGet('/')
        self.doGet(
            "/signup/freeform_post:signup", 
            {'username': 'spider', 
                'password': 'peterparker',
                'password____2': 'peterparker',
                'realname': 'Mr. Peter Parker'}
        )
        self.doGet('/me/0')
        self.updateUrlDict(self.result)
        


if __name__ == "__main__":
    spider = SimpleSpider()
    spider.seedUrls()
    spider.harvestUrls()

# vim:nofoldenable
