# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.
#

"""
Unit tests for the Blog powerup.
"""

from atop.test import unittest

from atop import store

from quotient import blogup
from quotient import searchup

from quotient.test import helper

class Blog(unittest.TestCase, helper.ProvisionerMixin):
    def dbSetUp(self):
        self.avatar = self.createAvatar([blogup.BlogUp])
        self.blog = blogup.IBlog(self.avatar)

    def dbTearDown(self):
        nc = searchup.ISearch(self.avatar).checkpointDefer
        nc and nc.cancel()

    def dbtestItemAdding(self):
        i1 = store.Item(self.avatar)
        self.blog.receive([], i1)
        i2 = store.Item(self.avatar)
        self.failUnless(self.blog.receive(["0"], i2))
        i3 = store.Item(self.avatar)
        self.failIf(self.blog.receive(["7"], i3))

        self.blog.addReply(i1, i2)

        self.assertEquals(list(self.blog.posts()), [i1])
        self.assertEquals(list(self.blog.posts(i1)), [i2])
