# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

# YEARGH
from atop.test import unittest

from quotient.mimemessage import *
from quotient.mimebakery import *

from quotient.test.helper import ProvisionerMixin

SIMPLE_ATTACHMENT = 'Here is some \xfc attachment garbage\n\n\nlets make sure its\xffpreservedcorrectly'

class BakeryTest(unittest.TestCase, ProvisionerMixin):
    def dbSetUp(self):
        self.bob = self.createAvatar((EmailPowerup, prefup.Prefup))

    def composeit(self, bodyText, attachment):
        foo = Recipe(self.bob,
                      to=["jethro@host2"],
                      cc=["jethro@host3"],
                      subject="make money fast")
        foo.text(bodyText)
        if attachment:
            foo.attach(attachment)
        return foo.bake()

    def dbtestSimple(self):
        m = self.composeit("hello world",
                           SIMPLE_ATTACHMENT)
        parts = [x for x in m.walk() if not x.is_multipart()]
        t, p = parts
        decpart = p.get_payload(True)
        self.assertEquals(t.get_payload(True), "hello world")
        self.assertEquals(decpart, SIMPLE_ATTACHMENT)
