# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from os.path import join as opj

from atop.store import Store, SubStore
from atop.powerup import IPowerStation
from atop.test import unittest
from atop.sched import SystemScheduler, IScheduler

from quotient.test import emaildata, helper
from quotient.mimemessage import IMIMEDelivery, EmailPowerup
from quotient.searchup import Searchup

class TestSearchup(unittest.TestCase, helper.ProvisionerMixin):
    storePowerups = [SystemScheduler]

    def dbSetUp(self):
        self.substore = self.createAvatar([EmailPowerup])
        self.searchup = IPowerStation(self.substore).installPowerup(Searchup)
        self.md = IMIMEDelivery(self.substore)
        self.searchup.indexPool(self.md.getArrivalRef().getItem())
        for m in emaildata.test_messages:
            self.md.createMIMEReceiver(True).feedStringNow(m)

    def dbTearDown(self):
        pass
        # nc = IScheduler(self.store).nextCall
        # nc and nc.cancel()

    def testSearch(self):
        hits = unittest.deferredResult(self.searchup.search('the'))
        self.failUnless(len(hits) >= 6, 'Expected at least 6 hits, got %s' % len(hits))
    testSearch.skip = 'This test needs to be iterated in the reacor of something.'
