# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.

from nevow.tags import *
from nevow import freeform

from twisted.web import resource

from quotient import provisioner
from quotient.web.root import Base, TabularBase, column
from quotient.taglib import page

class DefaultPowerupDisplay(Base):
    document = page(title=lambda foo: foo.powerupName)[
        freeform.configureIfPossible
        ]

class TabularPowerup(TabularBase):
    def render_name(self, context, data):
        if getattr(data, 'greyedOut', None):
            return data.name
        else:
            return a(href=data.storeID)[str(data.name)]
    column(render_name, True, 300)

    def render_status(self, context, data):
        if getattr(data, 'greyedOut', None):
            return "Started"
        return a(href=data.storeID)["Started"]
    column(render_status, True, 200)

class TabularProvisionedPowerup(TabularPowerup):
    def render_tank(self, context, data):
        av = context.locate(resource.IResource).avatar
        prov = provisioner.IProvisionable(data)
        return provisioner.IProvisioner(av).fueltanker[prov.tankID]
    column(render_tank, True, 50)
