# This module is part of the Quotient project and is Copyright 2003 Divmod:
# http://www.divmod.org/.  This is free software.  You can redistribute it
# and/or modify it under the terms of version 2.1 of the GNU Lesser General
# Public License as published by the Free Software Foundation.


from atop.powerup import Powerup

from nevow.renderer import ChildPrefixMixin

from twisted.web.resource import IResource, Resource

from quotient.mimemessage import EmailPowerup
from quotient.web.root import RootCrudMixin, Me, UserFrontPage

class WebPowerup(ChildPrefixMixin, RootCrudMixin, Powerup, Resource):
    __implements__ = Powerup.__implements__, Resource.__implements__
    powerupName = 'Web Login'

    isLeaf = False

    def __init__(self, avatar):
        Powerup.__init__(self, avatar)
        Resource.__init__(self)

    def setUpPools(self, avatar):
        avatar.setComponent(IResource, self)
        self.greyedOut = True
        self.invisible = True

    def logout(self):
        """
        Should probably do something here?
        """
        pass

    def child_(self, request):
        return UserFrontPage(self.store)

    def child_me(self, request):
        return Me(self.store)
