from twisted.python import log
from quotient import itempool, util, provisioner

# Hack to get around isinstance(email.Message.Message)
import spambayes.mboxutils as mbu
def echo(msg):
    return msg
mbu.get_message = lambda x:x

from spambayes.hammie import Hammie
from spambayes.classifier import Bayes
from spambayes.Options import options

startupCost = 0.001

class BayesianFiler:
    __implements__ = itempool.IMembrane

    trainTime = 0

    def __init__(self, store, pools):
        self.store = store
        self.pools = pools
        self.guesser = Hammie(Bayes())
        self.scope = util.Statoscope(name="bayes")

    def inspect(self, message):
        prov = self.store.avatar.provisioner
        if prov.deplete(provisioner.ETank.CLASSIFICATION, startupCost, True):
            self.scope.start()
            poolName, prob = self.guessPool(message)
            if poolName == 'arrival':
                poolName = 'clean'
            self.scope.finish()
            self.store.getItemByID(self.pools[poolName]).addItem(message)
            prov.deplete(provisioner.ETank.CLASSIFICATION, self.scope.lastElapsed, True)
            log.msg("Classifier: %s" % self.scope)
            if poolName == 'spam':
                return True
        else:
            self.store.getItemByID(self.pools['clean']).addItem(message)

    def guessPool(self, msg):
        guessed = self._guessPool(msg)
        msg.guessedPool = guessed[0]
        return guessed

    def _guessPool(self, msg):
        prob = self.guesser.score(msg)
        if prob < options['Categorization','ham_cutoff']:
            pool = 'clean'
        elif prob > options['Categorization', 'spam_cutoff']:
            pool = 'spam'
        else:
            # Unsure
            pool = 'arrival'
        return (pool, prob)

    def train(self, msg, isSpam):
        self.guesser.train(msg, isSpam)
        
    def getOutputs(self):
        return ['spam', 'clean', 'arrival']
