
extractorPatterns = {
    'words' : re.compile("\\w+"),
    'quotedlines': re.compile("^>.*", re.M),
    'phonenos': re.compile(r'(?:(\d{3})[ -\.])?(\d{3})[ -\.](\d{4})'),
    'questions': re.compile(r'(?:^|[.?!]\s)(.*\?)(?:\s|$)',re.M)
    }

def extractorate(pattern, message):
    for textPlainPart in message.getTypedParts('text/plain'):
        for m in re.finditer(r, textPlainPart):
            yield (m.group(), m.span())

def tokenize(msg, *kinds):
    extractorResults = {}
    for kind in kinds:
        name, pattern = extractorPatterns[kind]
        extractorResults[name] = extractorate(pattern, msg)
    return extractorResults

def temporalWords(msg):
    """
    General scheme:

     RELATIVE_DAY ::= today|tomorrow|yesterday|WEEKDAY
     WEEKDAY ::= [(last|next|this)] Monday|Tuesday|Wednesday ... 
                               Mon|Tue|Wed|Thu|... 
     DATE ::= mm/dd/yyyy | dd/mm/yy | mm-dd-yyyy... | # very similar to phone numbers...
              Thursday January 10 # < -- too hard for now?
     TIME ::= [h]h:mm [(PM/AM)] | noon
     MEAL ::= (lunch|dinner|breakfast|brunch|supper)[time]
     PERIOD ::= morning|afternoon|evening|night

     'Let's meet TUESDAY FOR LUNCH.'
     'Let's have LUNCH EARLY ON TUESDAY'
     'lunch on tuesday?'
     'tuesday, lunchtime'
     'Let's get together at 10/6/2003, around 11:00?'
                                       ^ ignore this word, allow for 2 or 3
                                       'garbage' words within a match between
                                       date and time
    # cases we will NOT handle
    
      'I think that we should get together soonish.  Maybe sometime next week,
      around tuesday?' # we might catch 'tuesday', but it could easily be the
      wrong tuesday.
      
    APPOINTMENT ::= WEEKDAY

    """
    for word in tokenize(msg, 'words')['words']:
        if word == 'today':
            pass
