# -*- coding: Latin-1 -*-

from twisted.cred import portal
from twisted.cred import checkers
from twisted.python import components

class IInternalAvatar(components.Interface):
    pass

class Avatar(components.Componentized):
    __implements__ = (IInternalAvatar,)

def noLogout():
    pass

##
## When will storq move into twisted.persisted!
##
class Realm:
    __implements__ = (portal.IRealm,)

    def __init__(self, users=None):
        if users is None:
            users = {}
        self.users = users

    def requestAvatar(self, avatarId, mind, *interfaces):
        if avatarId is checkers.ANONYMOUS:
            avatar = None
        else:
            avatar = self.users.setdefault(avatarId, Avatar())
        for iface in interfaces:
            avatarAspect = iface(avatar, default=None)
            if avatarAspect is not None:
                logout = getattr(avatarAspect, 'logout', noLogout)
                return (iface, avatarAspect, logout)
        raise NotImplementedError("None of the specified interfaces are supported by this realm")
