
def caps(c):
    return c.upper() == c

def methodNameToButtonLabel(mname):
    labelList = []
    word = ''
    lastWasUpper = False
    for letter in mname:
        if caps(letter) == lastWasUpper:
            # Continuing a word.
            word += letter
        else:
            # breaking a word OR beginning a word
            if lastWasUpper:
                # could be either
                if len(word) == 1:
                    # keep going
                    word += letter
                else:
                    # acronym
                    # we're processing the lowercase letter after the acronym-then-capital
                    lastWord = word[:-1]
                    firstLetter = word[-1]
                    labelList.append(lastWord)
                    word = firstLetter + letter
            else:
                # definitely breaking: lower to upper
                labelList.append(word)
                word = letter
        lastWasUpper = caps(letter)
    labelList[0] = labelList[0][0].upper() + labelList[0][1:]
    labelList.append(word)
    return ' '.join(labelList)

if __name__ == '__main__':
    print methodNameToButtonLabel('getArguments')
    print methodNameToButtonLabel('eatIt')
    print methodNameToButtonLabel('givePeaceAChance')
    print methodNameToButtonLabel('fetchHTTPStuffForWebDAV')
    print methodNameToButtonLabel('addPOP3Grabber')
    print methodNameToButtonLabel('burnCards')
