#!/usr/bin/env python2.3 

from twisted.spread import pb
from twisted.trial import util
from twisted.python import log
from twisted.internet import reactor, defer, error

from flooder import Flooder, Tee
from torture_userCreation import TweakableObserver, SignupTaskFactory
import torture_spider

def eb(failure):
    failure.trap(error.ConnectionRefusedError)
    log.debug(failure)
    return None
    #reactor.callWhenRunning(reactor.crash)

class RemoteControl:
    def started(self, result):
        log.msg("started remote torturer: %s" % result)

    def getToWork(self, result):
        log.msg('RemoteControl.getToWork result: %s' % result)
        self.obj.callRemote('getToWork').addCallbacks(self.started, eb)

    def config(self):
        kw = {'totalJobsLimit': 10,
              'activeJobsLimit': 2,
              'baseurl': 'http://192.168.1.55'
              }
        self.obj.callRemote('config', **kw).addCallbacks(self.getToWork, eb)

    def gotRoot(self, obj):
        self.obj = obj
        self.config()

    def startRemote(self, address='localhost'):
        self.remotesRunning = defer.Deferred()
        def _():
            factory = pb.PBClientFactory()
            reactor.connectTCP(address, 9999, factory)
            d = factory.getRootObject()
            d.addCallbacks(self.gotRoot, eb)
        reactor.callLater(0, _)
        return self.remotesRunning

if __name__ == "__main__":
    import os, sys
    import os.path as osp
    logname = 'torture.log'
    o = TweakableObserver(sys.stdout)
    log.addObserver(o._emit)
    log.startLogging(Tee(file(logname,'w'), sys.stdout), False)

    f = SignupTaskFactory()
    f.totalJobsLimit = 40
    f.activeJobsLimit = 3
    f.jobsPerSecond = 2

    rAddr = ['192.168.1.42', '192.168.1.1']
    rc = RemoteControl()

    def gettemGoin(addr):
        d = rc.startRemote(addr)
        d.addErrback(eb)
        return d

    dl = defer.DeferredList([gettemGoin(addr) for addr in rAddr])
    
        
#    util.deferredResult(d, timeout=20)
    def _():
        f.getToWork()
    dl.addCallback(_)

    reactor.run()

