#!/usr/bin/env python2.3 
import urllib, random, time

from twisted.trial import unittest, util
from twisted.internet import reactor, defer, error
from twisted.python import log, components
from twisted.application import service
from twisted.protocols import policies

import quotient
from quotient.web import newclient, functional
from quotient.test.simpleSpider import SimpleSpider

from flooder import Flooder, Tee
import task

def dfrDbg(self):
    if hasattr(self, 'debug'):
        import traceback
        traceback.print_stack()


class TweakableObserver(log.FileLogObserver):
    BLACK = 30
    RED = 31
    GREEN = 32
    YELLOW = 33
    BLUE = 34
    MAGENTA = 35
    CYAN = 36
    WHITE = 37

    def __init__(self, f):
        log.FileLogObserver.__init__(self, f)
        self.f = f


    def _emit(self, eventDict):
        def color(text, color):
            return '%s%s;1m%s%s0m' % ('\x1b[', color, text, '\x1b[')
      
        edm = eventDict['message']
        if eventDict['isError'] and eventDict.has_key('failure'):
            text = eventDict['failure'].getTraceback()
        elif 'debug' in eventDict:      # ignore debugging messages
            return
        elif 'clockOut' in eventDict:
            text = color("%s" % str(edm), self.RED)
        elif 'clockIn' in eventDict :
            text = color("%s" % str(edm), self.GREEN)
        elif 'avg' in eventDict :
            text = color("%s" % str(edm), self.YELLOW)
        elif 'lag' in eventDict :
            text = color("%s" % str(edm), self.CYAN)
        elif eventDict.has_key('format'):
            text = eventDict['format'] % eventDict
        elif eventDict.has_key('changedGlobal'):
            text = '           ' + eventDict['changedGlobal']
        else:
            text = ' '.join(map(str, edm))
            #return

        y,mon,d,h,min, sec,nnoo,rree,daylight = time.localtime(eventDict['time'])
        self.write("%0.4d/%0.2d/%0.2d %0.2d:%0.2d:%0.2d %s [%s] %s\n" %
                   (y, mon, d, h, min, sec, time.tzname[daylight],
                    eventDict['system'], text.replace("\n","\n\t")))
        self.flush()                    # hoorj!


def recordResult(result):
    #log.msg("result: %s" % result)
    #log.msg(result)
    pass

validChars = [chr(n) for n in range(65,90)]
validChars.extend([chr(n) for n in range(97,122)])

def randomString():
    from random import randint, choice
    s = validChars[:]
    random.shuffle(s)
    length = randint(4, 8)
    return ''.join(s[0:length])

class RandomUser(object):
    def __init__(self):
        self.usrname = randomString()
        self.pswd = randomString()
        self.realname = "%s %s" % (randomString(), randomString())

    def __str__(self):
        return "usrname: %s, pswd: %s, realname: %s" % self.userInfo

    userInfo = property(lambda self: (self.usrname, self.pswd, self.realname))
    
    def _getDictItems(self):
        return {'username': self.usrname,
                'password': self.pswd,
                'password____2': self.pswd,
                'realname': self.realname }

    dictItems = property(_getDictItems)


def eb(failure):
    log.debug('eb')
    failure.trap(NotImplementedError, error.ConnectionLost)
    log.debug(failure.value)
    return None


class SignupJob(Flooder): #, policies.TimeoutMixin):
    __implements__ = (task.IJob,)
    timeout = 20 
   
    def __init__(self, user):
        Flooder.__init__(self)
        self.user = user

    def __repr__(self):
        if hasattr(self, '_jid'):
            return "job %s" % self._jid
        return object.__repr__(self)


#    def _eb(self, error):
#        log.msg('error in signup', error)
#        log.msg(str(error.value))
#        return None

    def timeoutConnection(self):
        d, self.jobDone = self.jobDone, defer.Deferred() 
        d.errback(Exception('Timed Out'))
    
    def doWork(self):
        self.master.clockIn(self._jid)
        log.msg('SignupFlood.signup')
        log.msg('user:', self.user)

        def destroy(_):
            self.doGet('/perspective-destroy').addErrback(eb)

        def doSignup(_):
            log.msg('doSignup')
            self.doGet( "/signup/freeform_post:signup", 
                        {'username': self.user.usrname, 
                        'password': self.user.pswd,
                        'password____2': self.user.pswd,
                        'realname': self.user.realname} 
                      ).addCallback(destroy
                      ).addErrback(eb)

        self.doGet('/').addCallback(doSignup
                      ).addErrback(eb)
                      
        

class SignupTaskFactory(task.TaskFactory):
    baseurl = "http://localhost"
    __implements__ = (task.ITaskFactory,)
    
    def __init__(self):
        task.TaskFactory.__init__(self)

    def getToWork(self):
        log.debug("SignupTaskFactory.getToWork called")
        self.floodComplete = defer.Deferred()

        def _():
            self.startTime = time.time()
            task.TaskFactory.getToWork(self)

        reactor.callLater(0, _)
        return self.floodComplete

    def getAJob(self):
        task.TaskFactory.getAJob(self)
        j = SignupJob(user=RandomUser())
        j.master = self
        j.baseurl = self.baseurl
        return j
        
    def allJobsCompleted(self):
        log.msg('allJobsCompleted!')
        log.msg("completed %s jobs in %s sec" % (self._totalCompletedJobs, time.time() - self.startTime))
        d, self.floodComplete = self.floodComplete, None
        d.callback(None)



#from twisted.spread import pb
#
#class PBTaskFactory(pb.Root):
#    factory = None
#
#    def remote_getToWork(self):
#        self.f.getToWork()
#
#    def remote_config(self, **kw):
#        f = self.factory()
#        for k, v in kw.iteritems():
#            if hasattr(f, k):
#                setattr(f, k, v)
#        self.f = f
#
#    def remote_killServer(self):
#        from twisted.internet import reactor
#        reactor.crash()
#        
        
from twisted.python import components
from twisted.spread import flavors
components.registerAdapter(
        task.PBTaskFactoryAdapter,
        SignupTaskFactory,
        flavors.IPBRoot
)
        


    
if __name__ == "__main__":
    import os, sys
    import os.path as osp
    logname = 'torture.log'
#    o = TweakableObserver(sys.stdout)
#    log.addObserver(o._emit)
#    log.startLogging(file(logname,'w'), False)
    log.startLogging(Tee(file(logname,'w'),sys.stdout), False)
    
    f = SignupTaskFactory()
    f.totalJobsLimit = 30
    f.activeJobsLimit = 15
    
#    import hotshot
#    p = hotshot.Profile('tortureuser.prof',1,1)
#    
#    d = p.runcall(f.getToWork)
    d = f.getToWork()
    d.addBoth(lambda _: reactor.stop())
#        
#    import pdb
#    from twisted.python import failure
#    failure.startDebugMode()
#    dbg = pdb.Pdb()
#    try:
#        rcFile = open("../.pdbrc")
#    except IOError:
#        hasattr(sys, 'exc_clear') and sys.exc_clear()
#    else:
#        dbg.rcLines.extend(rcFile.readlines())
#    pdb.run("reactor.run()")

    reactor.run()


