#from twisted.trial import unittest
from twisted.python.util import OrderedDict
from twisted.web.microdom import parseString
from twisted.web.domhelpers import findElementsWithAttribute as findwa
from twisted.web.domhelpers import findNodes as findn
from twisted.web.domhelpers import findNodesNamed as findnn
from twisted.web.domhelpers import gatherTextNodes as gather

from os.path import join as opj

from quotient.web import functional

dontGoThere = ['/perspective-destroy', '/perspective-init']
badKeys = ['Next', 'Previouw', 'Prev', 'Logout']

class SimpleSpider(functional.FunctionalBase):
    urldict = {}
    harvestedURLs = []
    def __init__(self):
        functional.FunctionalBase.setUpClass(self)

    def crawl(self):
        self.seedUrls()
        self.harvestUrls()
        self.cleanup()
        self.fixUrls()

    def fixUrls(self):
        """adds a /me if necessary"""
        keys = self.urldict.keys()
        vals = self.urldict.values()
        remove = []
        for i, v in enumerate(vals):
            if v in dontGoThere:
                remove.append(i)
                continue
            if '/me' not in v:
                vals[i] = opj('/me', v)

            # i can do this because i know that 
            # len(keys) == len(values)
            if keys[i] in badKeys:
                print '\n\nFOUND BAD KEY %s!!\n\n\n' % keys[i]
                remove.append(i)
        for i in remove:
            del keys[i]
            del vals[i]
        
        self.urldict = dict(zip(keys, vals))
  
    def cleanup(self):
        functional.FunctionalBase.tearDownClass(self)

    def updateUrlDict(self, domstr):
        newdict = {}
        dom = parseString(domstr)
        for node in findnn(dom,'a'):
            if len(node.childNodes) == 1:
                name = node.childNodes[0].nodeValue
                if name not in self.urldict.keys():
                    url = node.getAttribute('href')
                    newdict[name] = url
                    #print 'name %s: = url: %s' % (name, url)
        self.urldict.update(newdict)

    def harvestUrls(self):
        for url in self.urldict.values():
            if url in dontGoThere:
                continue
            if '/me' not in url:
                #print 'getting /me/%s' % url
                self.doGet('/me/%s' % url, skipRestOnError=False)
            else:
                self.doGet(url)
            self.updateUrlDict(self.result)

    def seedUrls(self):
        self.doGet('/')
        self.doGet(
            "/signup/freeform_post:signup", 
            {'username': 'test', 
                'password': '123',
                'password____2': '123',
                'realname': 'Mr. Test'}
        )
        self.doGet('/me/0')
        self.updateUrlDict(self.result)
        


if __name__ == "__main__":
    spider = SimpleSpider()
    spider.seedUrls()
    spider.harvestUrls()
