#!/usr/bin/env python2.3

import sys

FILENAME   = 0
STATEMENTS = 2
UNCOVERED  = 3
RATIO      = 4

def main(filename):
    L = file(filename, 'r').readlines()
    L = [s.strip().split(' ') for s in L]
    decorated = [(e[-1], e) for e in L] 
    decorated.sort()
    undecorated = [e[1] for e in decorated]

    maxColSize = [0,0,0,0,0]
    
    for line in undecorated:
        for i, col in enumerate(line):
            if len(col) > maxColSize[i]:
                maxColSize[i] = len(col)

    formatted = []
    for line in undecorated:
        clean = []
        for i, col in enumerate(line):
            if i < 2 or i == 4:
                clean.append(col.ljust(maxColSize[i]))
            else:
                clean.append(col.rjust(maxColSize[i]))
        formatted.append(clean)

    for f in formatted:
        sys.stdout.write(' '.join(f) + '\n')

    
if __name__ == "__main__":
    if len(sys.argv) < 2:
        SystemExit('useage: sortCoverageResult.py [FILE]')
    main(sys.argv[1])
    
