from twisted.trial import unittest
from twisted.web.microdom import parseString
from twisted.web.domhelpers import findElementsWithAttribute as findwa
from twisted.web.domhelpers import findNodes as findn
from twisted.web.domhelpers import findNodesNamed as findnn
from twisted.web.domhelpers import gatherTextNodes as gather

from quotient.web import functional

from os.path import join as opj

from simpleSpider import SimpleSpider

testList = [ 
      ('Home',          ['Home','Inbox','Compose','People','Dashboard','Logout','Arrival','Blog','Clean','Images','ImagesQueue','Inbox','IndexingQueue','MailingLists','Outbox','People','ScheduledTasks''Sent','Spam','Trash','powerups']),
      ('Inbox',         ['Inbox']),
      ('Compose',       ["Send Mail to someone." ,"To" ,"CC" ,"Subject" ,"Body" ,"Attachment"]),
      ('People',        ["People"]),
      ('Dashboard',     ["powerups","Name","Status","External Accounts","Personal Preferences", "Scheduled Tasks","SpamBayes"]),
      ('Arrival',       ['Arrival', 'Contents']),
      ('Blog',          ['Blog', 'Contents']),
      ('Clean',         ['Clean']),
      ('Images',        ['Images']),
      ('Images Queue',  ['Images Queue']),
      ('Inbox',         ['Inbox']),
      ('Indexing Queue',['Indexing Queue']),
      ('Mailing Lists', ['Mailing Lists']),
      ('Outbox',        ['Outbox']),
      ('People',        ['People']),
      ('Scheduled Tasks',['Scheduled Tasks']),
      ('Sent',          ['Sent']),
      ('Spam',          ['Spam']),
      ('Trash',         ['Trash']),
      ('powerups',      ['powerups']),
      ('Logout',        ['Divmod Quotient', 'Welcome! Please log in.'])
]



#class aTest(functional.FunctionalBase):
#    def setUpClass(self):
#        functional.FunctionalBase.setUpClass(self)
#
#    def checkLink(self, link):
#        print link
#
#
#def makeCheckMethod(link):
#    def _(self):
#        self.checkLink(link)
#    return _
#
#def addTestMethods(klass):
#    import types
#    urls, names = urldict.values(), urldict.keys()
#    for n, url in enumerate(urls):
#        lc = makeCheckMethod(url)
#        testname = "test_%03d_%s" % (n, names[n].replace(' ', '_'))
#        lc = types.FunctionType(lc.func_code, lc.func_globals, testname, lc.func_defaults, lc.func_closure)
#        setattr(klass, testname, lc)
#        del lc
#
#
#addTestMethods(aTest)

spider = SimpleSpider()
spider.crawl()

class mTest(functional.FunctionalBase):
    print 'mTest'
    def setUpClass(self):
        functional.FunctionalBase.setUpClass(self)
    def tearDownClass(self):
        functional.FunctionalBase.tearDownClass(self)

def makeChecker(url, testname):
    def lf(self):
        self.checkLink(url)
    import types
    lc = types.FunctionType(lf.func_code, lf.func_globals, testname, lf.func_defaults, lf.func_closure)
    return lc

def addTestMethods(klass):
    spider.fixUrls()
    urls, names = spider.urldict.values(), spider.urldict.keys()
    testlist = []
    for i, url in enumerate(urls):
        testname = "test_%03d_%s" % (i, names[i].replace(' ', '_'))
        setattr(klass, testname, makeChecker(urls[i], testname))
        testlist.append("%s.%s" % (klass.__name__,testname))
    return testlist

testlist = addTestMethods(mTest)
print testlist

THE_FREAKING_TEST = mTest

__tests__ = [THE_FREAKING_TEST]
# vim:nofoldenable
