# functional tests
from cStringIO import StringIO

from twisted.web import microdom

from quotient.web import functional

# a few notes from the desk of the Anal-Retentive
#
# in blank mailbox folders:
#   - inconsistent sorting arrow 
#   - inconsistent "Name" column heading
#
# outbox "No Items." is positioned incorrectly
#
#  hey, why does the "Back to" topnav on the compose page have a link to "scheduled tasks"?




class BasicTests(functional.FunctionalBase):
    #skip = "buildbot hates us"
    
    def setUpClass(self):
        functional.FunctionalBase.setUpClass(self)
        self.arrowNames = ["forwards.png", "backwards.png"]

    def test_001_incorrectLogin(self):
        self.doGet("/perspective-init", {'username': 'test', 'password': 'asdfawerqwerqwer'})
        self.assertInResult("logged in incorrectly")

    def test_002_signUp(self):
        self.doGet(
            "/freeform_post:signup", 
            {'username': 'test', 
                'password': '123',
                'password____2': '123',
                'realname': 'Mr. Test'}
        )
        self.assertInResult('Personal Preferences')

    def test_003_sortListByName(self):
        self.doGet("/me/0",
                  {"index":"name",
                  "direction":"backwards",
                  "start": "" }
        )
        self.assertInResult('/images/icons/backwards.png"')

    def checkForNavigationMenu(self):
        self.assertInResult("Home")
        self.assertInResult("Inbox")
        self.assertInResult("Compose")
        self.assertInResult("People")
        self.assertInResult("Dashboard")
        self.assertInResult("Logout")

    def checkTabularFormat(self):
        self.assertInResult("Previous")
        self.assertInResult("Next")
        self.assertInResult("Name", 'name heading not found')
        anm = self.arrowNames
        self.assert_(anm[0] in self.result or anm[1] in self.result, 'missing sort direction arrow')        # we should have an arrow of some sort

    def checkTopNav(self):
        self.assertInResult("Back to")
        
#    def test_004_compose(self):
#        self.doGet("/me/compose")
#        self.assertInResult("Send Mail to someone.")
#        self.assertInResult("To")
#        self.assertInResult("CC")
#        self.assertInResult("Subject")
#        self.assertInResult("Body")
#        self.assertInResult("Attachment")
#        self.checkTopNav() 
#   
#    def test_005_mailingLists(self):
#        self.doGet("/me/29")    def searchDom(self, html):
#        self.assertInResult("Mailing Lists")
#        self.checkForNavigationMenu()
#        self.checkTopNav()
#        self.checkTabularFormat() 
#
#    test_005_mailingLists.todo = "tabular format bug, see notes" 
#        
#    def test_006_outbox(self):
#        self.doGet("/me/16")
#        self.assertInResult("Outbox")
#        self.checkForNavigationMenu() 
#        self.checkTopNav()
#        self.assertInResult("Name")
#        self.checkTabularFormat()
#
#    test_006_outbox.todo = "tabular format bug, see notes" 
#    
#
#    def test_007_sent(self):
#        self.doGet("/me/18")
#        self.assertInResult("Sent")
#        self.checkForNavigationMenu()
#        self.checkTopNav()
#        self.checkTabularFormat()
#
#    test_007_sent.todo = "tabular format bug, see notes" 
#
#    def test_008_spam(self):
#        self.doGet("/me/21")
#        self.assertInResult("Spam")
#        self.checkForNavigationMenu()
#        self.checkTopNav()
#        self.checkTabularFormat()
#
#    test_008_spam.todo = "tabular format bug, see notes" 
#
#    def test_009_trash(self):
#        self.doGet("/me/26")
#        self.assertInResult("Trash")
#        self.assertInResult("Trash/Spam")
#        self.checkForNavigationMenu()
#        self.checkTopNav()
#        self.checkTabularFormat()
#
#    test_009_trash.todo = "tablular format bug, see notes"
#
#    def test_010_home(self):
#        self.doGet("/me/0")
#        self.assertInResult("Home")
#        self.assertInResult("Inbox")
#        self.assertInResult("Mailing Lists")
#        self.assertInResult("Outbox")
#        self.assertInResult("Sent")
#        self.assertInResult("Spam")
#        self.assertInResult("Trash")
#        self.checkTabularFormat()
#
#    #test_010_home.todo = "tablular format bug, see notes"
#
#    def test_011_people(self):
#        self.doGet("/me/38")
#        self.assertInResult("People")
#        self.checkForNavigationMenu()
#        self.checkTopNav()
#        self.checkTabularFormat()
#
#    test_011_people.todo = "tabular format bug, see notes" 
#
#    def test_012_dashboard(self):
#        self.doGet("/me/2")
#        self.assertInResult("powerups")
#        self.assertInResult("Name")
#        self.assertInResult("Status")
#        self.assertInResult("External Accounts")
#        self.assertInResult("Personal Preferences")
#        self.assertInResult("Scheduled Tasks")
#        self.assertInResult("SpamBayes")
#        self.assertInResult("Trash Man")
#        self.assertInResult("Whitelist")
#        self.checkTopNav()
#        self.checkTabularFormat()
#
    #test_012_dashboard.todo = "table format bug, see notes"

    def findNodes(self, stringRep, nodeClass, value):
        #print "value: %s" % value
        doc = microdom.parse(StringIO(stringRep)) 
        self.foundNodes = []
        def _(node):
            #print node
            if isinstance(node, nodeClass):
                #print "grabber in? %s: value in? %s: nodeValue: %s" % (
                        #'Grabber' in node.nodeValue, 
                        #value in node.nodeValue, 
                        #node.nodeValue)
                if value in node.nodeValue:
                    #print "\n\n --> found Node!! <-- \n\n"
                    self.foundNodes.append(node)
                    return
            if node.hasChildNodes():
                for cn in node.childNodes:
                    _(cn)
        _(doc)
        n = self.foundNodes 
        del self.foundNodes 
        return n

    def flattenNode(self, node):
        self.nodelines = []
        def _(_node):
            self.nodelines.append(_node)
            if _node.hasChildNodes():
                for cn in _node.childNodes:
                    _(cn)

        _(node)
        for n in self.nodelines: print n
        del self.nodelines


    def test_013_externalAccounts(self):
        self.doGet("/me/10")
        grabbers = ["Pop", "IMAP"]
        fmt = "Add %s Grabber"
        for g in grabbers:
            self.assertInResult(fmt % g)
        self.assertInResult("Password")
        self.assertInResult("Again")
        self.assertInResult("Host")
        self.assertInResult("Port")
        self.assertInResult("Email Address")
        self.assertInResult("Messages Per Grab")
        self.assertInResult("SSL")
        self.assertInResult("Deletion Age")
        self.assertInResult("grabbers")
        self.checkTopNav()
        nodes = self.findNodes(self.result, microdom.Text, 'Grabber')
        print 'nodes: %s' % nodes
        if nodes is not None:
            for n in nodes:
                self.flattenNode(n)
        else:
            print 'node not found'

    #test_013_externalAccounts.todo = 'working on it'

#slyphon: you can post to that form by getting the url 
# http://localhost:8485/me/10/freeform_post:importDirectory?dirname=%2fUsers%2fdp%2fDevelopment%2fQuotient%2fquotient%2ftestdata
