#!/usr/bin/env python2.3


from nevow import renderer, stan
from nevow.tags import *
from twisted.xish.domish import escapeToXml

import StyleSheet
import pdb
import re

TRACE = False
DEBUG = True

class Base(renderer.Renderer):
    '''the class responsible for most of the rendering in the application.
provides the basic page setup for subclasses to override'''
    # initializs the IDataStore instance we'll be using in subclassed pages
    # this can be changed to whatever particular implementation we need for a
    # given situation (PickleStorage, etc.)
#    storage = CSVStorage.CSVStorage('storage/')
    storage = RDBStorage.RDBStorage()

    def __init__(self, *args, **kwargs):
        if 'storage' in kwargs:
            self.storage = kwargs['storage']
        renderer.Renderer.__init__(self)

    def render_style(self,context,data):
        '''loads the css into the page'''
        return context.tag[ head[ style(type="text/css", media="all")[ StyleSheet.text ] ] ]

    def render_menu(self, context, data):
        '''provides a common menu for each page'''
        return context.tag[ div[ table(class_='menu')[ tr[ td[ "menu" ] ] ] ] ]

    def render_links(self, context, data):
        '''renders the links on this page'''
        return context.tag[ div[ table(_class="content")[ tr[ td[ "links" ] ] ] ] ] 

    document = html(data=self.storage)[
                    head[ self.render_style ],
                    body[ 
                          div[ self.render_links ],
                          div[ self.render_menu  ]
                    ]
               ]
                    
                    

